////////////////////////////////////////////////////////////////////////
// ibox.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.ibox")

// <%pre>
#line 1 "ibox.ecpp"


#include <setup.h>
#include <tools.h>
#include <epg_events.h>
#include <recman.h>
#include <timerconflict.h>

#include <vdr/menu.h>

using namespace vdrlive;
using namespace std;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("ibox");

static const char* rawData = "\030\000\000\000\031\000\000\000\032\000\000\000\033\000\000\000\034\000\000\000\035\000"
  "\000\000\n\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("ibox " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
int update = qparam.get< int >("update");
  // </%args>

#line 19 "ibox.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 20 "ibox.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
#line 21 "ibox.ecpp"
  typedef TimerConflictNotifier timerNotifier_type;
  TNT_SESSION_SHARED_VAR(TimerConflictNotifier, timerNotifier, ());   // <%session> TimerConflictNotifier timerNotifier
  _tnt_ignore_unused<timerNotifier_type>(timerNotifier);
  // <%cpp>
#line 23 "ibox.ecpp"

	if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");
	string EMPTY_STR;
	tChannelID prev_chan;
	tChannelID next_chan;
	reply.setContentType( "application/xml" );

	if (update_status != update) {
		update_status = update;
	}

	string infoMsg;
	string infoUrl;

	if (timerNotifier.ShouldNotify()) {
		infoMsg = timerNotifier.Message();
		infoUrl = "timerconflicts.html";
	}

	const char* NowReplaying = cReplayControl::NowReplaying();

	EpgInfoPtr epgEvent;

	if (NowReplaying) {
		RecordingsManagerPtr recManager = LiveRecordingsManager();
#if VDRVERSNUM >= 20301
		// is is OK to lock here, because CreateEpgInfo will *not* lock other lists
		LOCK_RECORDINGS_READ;
		cRecording *recording = (cRecording *)Recordings->GetByName(NowReplaying);
#else
		cRecording *recording = Recordings.GetByName(NowReplaying);
#endif
		if (recording) {
			epgEvent = EpgEvents::CreateEpgInfo(recManager->Md5Hash(recording),
												recording,
												tr("playing recording"));
		}
	}
	else {
		string CHANNEL_STR("channel");
#if VDRVERSNUM >= 20301
		LOCK_CHANNELS_READ;
#else
		ReadLock channelsLock( Channels );
#endif

		if (cDevice::CurrentChannel()) {
			const int SKIP_GAP = 1;
#if VDRVERSNUM >= 20301
			cChannel* Channel = (cChannel *)Channels->GetByNumber(cDevice::CurrentChannel());

			cChannel* tmp = (cChannel *)Channels->GetByNumber(Channels->GetPrevNormal(cDevice::CurrentChannel()), -SKIP_GAP);
#else
			cChannel* Channel = Channels.GetByNumber(cDevice::CurrentChannel());

			cChannel* tmp = Channels.GetByNumber(Channels.GetPrevNormal(cDevice::CurrentChannel()), -SKIP_GAP);
#endif
			if (tmp)
				prev_chan = tmp->GetChannelID();
#if VDRVERSNUM >= 20301
			tmp = (cChannel *)Channels->GetByNumber(Channels->GetNextNormal(cDevice::CurrentChannel()), SKIP_GAP);
#else
			tmp = Channels.GetByNumber(Channels.GetNextNormal(cDevice::CurrentChannel()), SKIP_GAP);
#endif
			if (tmp)
				next_chan = tmp->GetChannelID();

			const string chanName(Channel->Name());
#if VDRVERSNUM >= 20301
			LOCK_SCHEDULES_READ;
#else
			cSchedulesLock schedulesLock;
			const cSchedules* Schedules = cSchedules::Schedules(schedulesLock);
#endif
			const cSchedule *Schedule = Schedules->GetSchedule(Channel);

			if (Schedule) {
				const cEvent *Event = Schedule->GetPresentEvent();
				if (Event) {
					epgEvent = EpgEvents::CreateEpgInfo(Channel,
														Event,
														CHANNEL_STR.c_str());
				}
				else {
					const string noInfo(tr("no epg info for current event!"));
					epgEvent = EpgEvents::CreateEpgInfo(CHANNEL_STR,
														chanName,
														noInfo);
				}
			}
			else {
				const string noInfo(tr("no epg info for current channel!"));
				epgEvent = EpgEvents::CreateEpgInfo(CHANNEL_STR,
													Channel->Name(),
													noInfo);
			}
		}
		else {
			const string chanName(tr("no current channel!"));
			epgEvent = EpgEvents::CreateEpgInfo(CHANNEL_STR,
												chanName,
												chanName);
		}
	}
	if (!epgEvent) {
		const string ERROR_STR("error");
		const string noInfo(tr("error retrieving status info!"));
		const string chanName(tr("no current channel!"));
		epgEvent = EpgEvents::CreateEpgInfo(ERROR_STR,
											chanName,
											noInfo);
	}
	else {
		if (prev_chan.Valid() && next_chan.Valid())
		{

  // <& xmlresponse.ibox ...
  { 
#line 139 "ibox.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 139 "ibox.ecpp"
    _tnt_cq0.add( "caption", (epgEvent->Caption()));
#line 139 "ibox.ecpp"
    _tnt_cq0.add( "currentTime", (epgEvent->CurrentTime(tr("%I:%M:%S %p"))));
#line 139 "ibox.ecpp"
    _tnt_cq0.add( "duration", (epgEvent->StartTime(tr("%I:%M %p")) + string(" - ") + epgEvent->EndTime(tr("%I:%M %p"))));
#line 139 "ibox.ecpp"
    _tnt_cq0.add( "elapsed", (epgEvent->Elapsed()));
#line 139 "ibox.ecpp"
    _tnt_cq0.add( "infoMsg", (infoMsg));
#line 139 "ibox.ecpp"
    _tnt_cq0.add( "infoUrl", (infoUrl));
#line 139 "ibox.ecpp"
    _tnt_cq0.add( "next_chan", (next_chan));
#line 139 "ibox.ecpp"
    _tnt_cq0.add( "prev_chan", (prev_chan));
#line 139 "ibox.ecpp"
    _tnt_cq0.add( "title", (epgEvent->Title()));
#line 139 "ibox.ecpp"
    _tnt_cq0.add( "type", (epgEvent->Id()));
#line 139 "ibox.ecpp"
    _tnt_cq0.add( "update", (update_status));
#line 139 "ibox.ecpp"
    callComp(tnt::Subcompident(std::string(), "xmlresponse", "ibox"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[0]; // \n
#line 140 "ibox.ecpp"

		}
		else if (prev_chan.Valid()) {

  // <& xmlresponse.ibox ...
  { 
#line 144 "ibox.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 144 "ibox.ecpp"
    _tnt_cq1.add( "caption", (epgEvent->Caption()));
#line 144 "ibox.ecpp"
    _tnt_cq1.add( "currentTime", (epgEvent->CurrentTime(tr("%I:%M:%S %p"))));
#line 144 "ibox.ecpp"
    _tnt_cq1.add( "duration", (epgEvent->StartTime(tr("%I:%M %p")) + string(" - ") + epgEvent->EndTime(tr("%I:%M %p"))));
#line 144 "ibox.ecpp"
    _tnt_cq1.add( "elapsed", (epgEvent->Elapsed()));
#line 144 "ibox.ecpp"
    _tnt_cq1.add( "infoMsg", (infoMsg));
#line 144 "ibox.ecpp"
    _tnt_cq1.add( "infoUrl", (infoUrl));
#line 144 "ibox.ecpp"
    _tnt_cq1.add( "prev_chan", (prev_chan));
#line 144 "ibox.ecpp"
    _tnt_cq1.add( "title", (epgEvent->Title()));
#line 144 "ibox.ecpp"
    _tnt_cq1.add( "type", (epgEvent->Id()));
#line 144 "ibox.ecpp"
    _tnt_cq1.add( "update", (update_status));
#line 144 "ibox.ecpp"
    callComp(tnt::Subcompident(std::string(), "xmlresponse", "ibox"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[1]; // \n
#line 145 "ibox.ecpp"

		}
		else if (next_chan.Valid()) {

  // <& xmlresponse.ibox ...
  { 
#line 149 "ibox.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 149 "ibox.ecpp"
    _tnt_cq2.add( "caption", (epgEvent->Caption()));
#line 149 "ibox.ecpp"
    _tnt_cq2.add( "currentTime", (epgEvent->CurrentTime(tr("%I:%M:%S %p"))));
#line 149 "ibox.ecpp"
    _tnt_cq2.add( "duration", (epgEvent->StartTime(tr("%I:%M %p")) + string(" - ") + epgEvent->EndTime(tr("%I:%M %p"))));
#line 149 "ibox.ecpp"
    _tnt_cq2.add( "elapsed", (epgEvent->Elapsed()));
#line 149 "ibox.ecpp"
    _tnt_cq2.add( "infoMsg", (infoMsg));
#line 149 "ibox.ecpp"
    _tnt_cq2.add( "infoUrl", (infoUrl));
#line 149 "ibox.ecpp"
    _tnt_cq2.add( "next_chan", (next_chan));
#line 149 "ibox.ecpp"
    _tnt_cq2.add( "title", (epgEvent->Title()));
#line 149 "ibox.ecpp"
    _tnt_cq2.add( "type", (epgEvent->Id()));
#line 149 "ibox.ecpp"
    _tnt_cq2.add( "update", (update_status));
#line 149 "ibox.ecpp"
    callComp(tnt::Subcompident(std::string(), "xmlresponse", "ibox"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[2]; // \n
#line 150 "ibox.ecpp"

		}
		else {

  // <& xmlresponse.ibox ...
  { 
#line 154 "ibox.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 154 "ibox.ecpp"
    _tnt_cq3.add( "caption", (epgEvent->Caption()));
#line 154 "ibox.ecpp"
    _tnt_cq3.add( "currentTime", (epgEvent->CurrentTime(tr("%I:%M:%S %p"))));
#line 154 "ibox.ecpp"
    _tnt_cq3.add( "duration", (epgEvent->StartTime(tr("%I:%M %p")) + string(" - ") + epgEvent->EndTime(tr("%I:%M %p"))));
#line 154 "ibox.ecpp"
    _tnt_cq3.add( "elapsed", (epgEvent->Elapsed()));
#line 154 "ibox.ecpp"
    _tnt_cq3.add( "infoMsg", (infoMsg));
#line 154 "ibox.ecpp"
    _tnt_cq3.add( "infoUrl", (infoUrl));
#line 154 "ibox.ecpp"
    _tnt_cq3.add( "title", (epgEvent->Title()));
#line 154 "ibox.ecpp"
    _tnt_cq3.add( "type", (epgEvent->Id()));
#line 154 "ibox.ecpp"
    _tnt_cq3.add( "update", (update_status));
#line 154 "ibox.ecpp"
    callComp(tnt::Subcompident(std::string(), "xmlresponse", "ibox"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n
#line 155 "ibox.ecpp"

		}
	}

  reply.out() << _tntChunks[4]; // \n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
