////////////////////////////////////////////////////////////////////////
// xmlresponse.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.xmlresponse")

// <%pre>
#line 1 "xmlresponse.ecpp"


#include <i18n.h>

using namespace std;
using namespace vdrlive;

string const XMLHEADER = "<?xml version=\"1.0\" encoding=\"" + LiveI18n().CharacterEncoding() + "\"?>";


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class ajax_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        ajax_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class ibox_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        ibox_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    ajax_type ajax;
    ibox_type ibox;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("xmlresponse");

static const char* rawData = "h\000\000\000i\000\000\000k\000\000\000\207\000\000\000\234\000\000\000\236\000\000\000"
  "\300\000\000\000\325\000\000\000\351\000\000\000\352\000\000\000\354\000\000\000%\001\000\000z\001\000\000\230\001"
  "\000\000\254\001\000\000\303\001\000\000\327\001\000\000\354\001\000\000\004\002\000\000\034\002\000\0005\002\000\000"
  "Y\002\000\000l\002\000\000\200\002\000\000\221\002\000\000\234\002\000\000\n\n\n\n<service>\n  <request name=\"\">\n "
  "    <param name=\"\"></param>\n  </request>\n  <response></response>\n  <error></error>\n</service>\n\n\n\n\n<service"
  ">\n  <request name=\"ibox\">\n\t<param name=\"update\"></param>\n  </request>\n  <response>1</response>\n  <error></e"
  "rror>\n  <values>\n\t<update></update>\n\t<epginfo>\n\t  <type></type>\n\t  <caption></caption>\n\t  <timenow></timen"
  "ow>\n\t  <name></name>\n\t  <duration></duration>\n\t  <elapsed></elapsed>\n\t  <nextchan></nextchan>\n\t  <prevchan>"
  "</prevchan>\n\t</epginfo>\n  </values>\n  <info>\n\t<message></message>\n    <url></url>\n  </info>\n</service>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    ajax(*this, "ajax"),
    ibox(*this, "ibox")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("xmlresponse " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n\n
  reply.out() << _tntChunks[8]; // \n
  reply.out() << _tntChunks[9]; // \n\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::ajax_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("xmlresponse::ajax " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
string name = qparam.get< string >("name");
string pname = qparam.get< string >("pname");
string value = qparam.get< string >("value");
bool result = qparam.get< bool >("result");
string error = qparam.get< string >("error");
  // </%args>

  // <%cpp>
#line 22 "xmlresponse.ecpp"
  reply.out() << ( XMLHEADER );
  reply.out() << _tntChunks[2]; // \n<service>\n  <request name="
#line 24 "xmlresponse.ecpp"
  reply.sout() << ( name );
  reply.out() << _tntChunks[3]; // ">\n     <param name="
#line 25 "xmlresponse.ecpp"
  reply.sout() << ( pname );
  reply.out() << _tntChunks[4]; // ">
#line 25 "xmlresponse.ecpp"
  reply.sout() << ( value );
  reply.out() << _tntChunks[5]; // </param>\n  </request>\n  <response>
#line 27 "xmlresponse.ecpp"
  reply.sout() << ( result );
  reply.out() << _tntChunks[6]; // </response>\n  <error>
#line 28 "xmlresponse.ecpp"
  reply.sout() << ( error );
  reply.out() << _tntChunks[7]; // </error>\n</service>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::ibox_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("xmlresponse::ibox " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int update = qparam.get< int >("update");
string type = qparam.get< string >("type");
string currentTime = qparam.get< string >("currentTime");
string caption = qparam.get< string >("caption");
string title = qparam.get< string >("title");
string duration = qparam.get< string >("duration");
int elapsed = qparam.get< int >("elapsed");
string prev_chan = qparam.get< string >("prev_chan");
string next_chan = qparam.get< string >("next_chan");
string infoMsg = qparam.get< string >("infoMsg");
string infoUrl = qparam.get< string >("infoUrl");
  // </%args>

  // <%cpp>
#line 48 "xmlresponse.ecpp"
  reply.out() << ( XMLHEADER );
  reply.out() << _tntChunks[10]; // \n<service>\n  <request name="ibox">\n\t<param name="update">
#line 51 "xmlresponse.ecpp"
  reply.sout() << ( update );
  reply.out() << _tntChunks[11]; // </param>\n  </request>\n  <response>1</response>\n  <error></error>\n  <values>\n\t<update>
#line 56 "xmlresponse.ecpp"
  reply.sout() << ( update );
  reply.out() << _tntChunks[12]; // </update>\n\t<epginfo>\n\t  <type>
#line 58 "xmlresponse.ecpp"
  reply.sout() << ( type );
  reply.out() << _tntChunks[13]; // </type>\n\t  <caption>
#line 59 "xmlresponse.ecpp"
  reply.sout() << ( caption );
  reply.out() << _tntChunks[14]; // </caption>\n\t  <timenow>
#line 60 "xmlresponse.ecpp"
  reply.sout() << ( currentTime );
  reply.out() << _tntChunks[15]; // </timenow>\n\t  <name>
#line 61 "xmlresponse.ecpp"
  reply.sout() << ( title );
  reply.out() << _tntChunks[16]; // </name>\n\t  <duration>
#line 62 "xmlresponse.ecpp"
  reply.sout() << ( duration );
  reply.out() << _tntChunks[17]; // </duration>\n\t  <elapsed>
#line 63 "xmlresponse.ecpp"
  reply.sout() << ( elapsed );
  reply.out() << _tntChunks[18]; // </elapsed>\n\t  <nextchan>
#line 64 "xmlresponse.ecpp"
  reply.sout() << ( next_chan );
  reply.out() << _tntChunks[19]; // </nextchan>\n\t  <prevchan>
#line 65 "xmlresponse.ecpp"
  reply.sout() << ( prev_chan );
  reply.out() << _tntChunks[20]; // </prevchan>\n\t</epginfo>\n  </values>\n
#line 68 "xmlresponse.ecpp"

if (!infoMsg.empty()) {

  reply.out() << _tntChunks[21]; //   <info>\n\t<message>
#line 72 "xmlresponse.ecpp"
  reply.sout() << ( infoMsg );
  reply.out() << _tntChunks[22]; // </message>\n    <url>
#line 73 "xmlresponse.ecpp"
  reply.sout() << ( infoUrl );
  reply.out() << _tntChunks[23]; // </url>\n  </info>\n
#line 75 "xmlresponse.ecpp"

}

  reply.out() << _tntChunks[24]; // </service>\n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
